/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * 
 * Read Me
 * 1)put graphList.txt in running folder
 * 2)run StabilityPolynomial.java
 * 3)run Main.java
 */

package sfactor;

import java.io.IOException;
import java.util.*;

/**
 *
 * @author ranjie
 */
public class Main {

    public static ArrayList< String[]> findSFactor(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization(graphListPath,pariResultPath);
        int n = polynomialsList.size();
        ArrayList< String[]> sFactorsList = new ArrayList< String[]>();

        for (int i = 0; i < n; i++){
            PolynomialRecord polyProduct = new PolynomialRecord();
            polyProduct = polynomialsList.get(i);
            for (int j = 0; j< n; j++) {
                PolynomialRecord polyDivide = polynomialsList.get(j);

                if (polyDivisionCheck(polyProduct, polyDivide)){
                    PolynomialRecord polyLeft = polyDivision(polyProduct,polyDivide);
                    boolean find = false;
                    for (int k = j+1 ; k < n; k++){
                        if (polynomialEqual(polynomialsList.get(k),polyLeft)){
                            String sfactor[] = new String[3];
                            sfactor[0]= polynomialsList.get(i).getId();
                            sfactor[1]= polynomialsList.get(j).getId();
                            sfactor[2]= polynomialsList.get(k).getId();
                            sFactorsList.add(sfactor);
                            find = true;
                        }
                    }//go through the whole list again, check if left part has company
                }//if
            }

        }//check every polynomial if it is a production of any other two polys

        return sFactorsList;

    }

    public static void displaySFactorsList(ArrayList< String[]> sFactorsList){
        System.out.println("we have " + sFactorsList.size() + "  sfactors");
        for (String[] anFinding : sFactorsList ){
            System.out.println( anFinding[0]
                    + "=" +anFinding[1]+ "X" + anFinding[2]);
            //System.out.println("-----------");
        }
    }

    public static boolean polynomialEqual(PolynomialRecord poly1,PolynomialRecord poly2){
        ArrayList<Factor> poly1Factors = poly1.getFactorsList();
        ArrayList<Factor> poly2Factors = poly2.getFactorsList();
        int num = poly1Factors.size();
        int num2 = poly2Factors.size();
        boolean polyEqual = true;

        if(poly2Factors.size()!= num){polyEqual= false;}


        boolean factorsEqual[]= new boolean[num];
        for(int i = 0; i< num; i++){
            factorsEqual[i]=false;
            String factorBody1 = poly1Factors.get(i).getBody();
            for(int j = 0; j < num2; j++){
                String factorBody2 = poly2Factors.get(j).getBody();
                if (factorBody1.equals(factorBody2)
                        && poly1Factors.get(i).getPower()== poly2Factors.get(j).getPower() )
                    factorsEqual[i]=true;//find the same one, than true
            }
        }
        for (int i=0; i < num; i++ ){
            if (factorsEqual[i] == false )
                polyEqual = false;
        }
        
        return polyEqual;
    }

    public static void testPolynomialEqual(){
        Factor factor1 = new Factor();
        factor1.setBody("3+p");
        factor1.setPower(4);

        Factor factor2 = new Factor();
        factor2.setBody("2+p");
        factor2.setPower(4);

        Factor factor3 = new Factor();
        factor3.setBody("2+p");
        factor3.setPower(1);

        Factor factor4 = new Factor();
        factor4.setBody("3+p");
        factor4.setPower(4);

        Factor factor5 = new Factor();
        factor5.setBody("2-p");
        factor5.setPower(2);

        PolynomialRecord poly1 = new PolynomialRecord();
        poly1.getFactorsList().add(factor1);
        poly1.getFactorsList().add(factor2);
        poly1.setId("10100101");

        PolynomialRecord poly2 = new PolynomialRecord();
        poly2.getFactorsList().add(factor3);
        poly2.getFactorsList().add(factor4);
        //poly2.getFactorsList().add(factor5);
        poly2.setId("111111101");

        boolean ans = polynomialEqual(poly1,poly2);
        System.out.println("equal test is " + ans);

    }


    public static PolynomialRecord polyDivision(PolynomialRecord polyProduction, PolynomialRecord polyDivisor) {
        // Production/Divisor

        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();

        ArrayList<Factor> productFactors = polyProduction.getFactorsList();
        
        ArrayList<Factor> leftFactors = new ArrayList<Factor>();
        for (int i=0; i < productFactors.size(); i++){
            Factor tempFactor = new Factor();
            tempFactor.setBody(productFactors.get(i).getBody());
            tempFactor.setPower(productFactors.get(i).getPower());
            leftFactors.add(tempFactor);
        }//copy productFactors

        
        //Factor emptyFactor = new Factor();
        //for(int i = 0; i < productFactors.size(); i++){
        //    leftFactors.add(emptyFactor);
        //}

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            for (int j=0; j < productFactors.size(); j++){// j >= i  
                if ( divideFactors.get(i).getBody().equals(productFactors.get(j).getBody() ) ){
                    int diverPower = divideFactors.get(i).getPower();
                    int productorPower = productFactors.get(j).getPower();
                    int leftPower = productorPower - diverPower;
                    leftFactors.get(j).setPower(leftPower);
                }
            }
        }//all divFactors done

        int num = leftFactors.size();
        for (int i = num-1; i >= 0 ; i-- ){//remove objects, not effecting the index
            if (leftFactors.get(i).getPower()<=0)
                leftFactors.remove(i);
        }// remove dead factor

        PolynomialRecord leftPolynomial = new PolynomialRecord();// may have problem about copy
        leftPolynomial.setFactorsList(leftFactors);

        return leftPolynomial;

    }



    public static boolean polyDivisionCheck(PolynomialRecord polyProduction, PolynomialRecord polyDivisor) {
        // DividEnd/Divisor
        boolean canDivide = false;
        ArrayList<Factor> divideFactors = polyDivisor.getFactorsList();
        ArrayList<Factor> productFactors = polyProduction.getFactorsList();

        boolean canDivideFactor[] = new boolean[divideFactors.size()];//each divfactor have a flag

        for (int i=0; i < divideFactors.size(); i++ ){
            //check if this aDivideFactor can be divided
            canDivideFactor[i]= false;
            for (Factor aProductFactor : productFactors){
                if ( divideFactors.get(i).getBody().equals(aProductFactor.getBody())
                    && divideFactors.get(i).getPower() <= aProductFactor.getPower() )
                    canDivideFactor[i]= true;
            }
        }//all DivideFactor check, flag set canDivideFactor[] ready

        canDivide = true;
        for (int i=0; i < divideFactors.size(); i++ ){
            if (canDivideFactor[i]== false )
                canDivide = false;
        }//if any one failed, all failed

        return canDivide;
    }

    

    public static void testDivisionCheck(){
        Factor factor1 = new Factor();
        factor1.setBody("1+p");
        factor1.setPower(2);

        Factor factor2 = new Factor();
        factor2.setBody("2+p");
        factor2.setPower(3);

        Factor factor3 = new Factor();
        factor3.setBody("2+p");
        factor3.setPower(3);

        Factor factor4 = new Factor();
        factor4.setBody("1+p");
        factor4.setPower(2);

        Factor factor5 = new Factor();
        factor5.setBody("2-p");
        factor5.setPower(2);

        PolynomialRecord poly1 = new PolynomialRecord();
        poly1.getFactorsList().add(factor1);
        //poly1.getFactorsList().add(factor2);
        poly1.setId("10100101");

        PolynomialRecord poly2 = new PolynomialRecord();
        poly2.getFactorsList().add(factor3);
        poly2.getFactorsList().add(factor4);
        //poly2.getFactorsList().add(factor5);
        poly2.setId("111111101");

        boolean result = polyDivisionCheck(poly2, poly1);
        System.out.print("test result is " + result);

    }

    public static void Debug(String graphListPath, String pariResultPath) {
        ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization(graphListPath,pariResultPath);
        ResultConverter.displayPolynomial(polynomialsList.get(polynomialsList.size()-1));

    }


    public static void showSFactorResult(String graphListPath, String pariResultPath) {
        //ArrayList<PolynomialRecord> polynomialsList = ResultConverter.Normalization("graphList.txt","pariResultFake.txt");
        //ResultConverter.displayPolyRecords(polynomialsList);
        //testDivisionCheck();
        //testDivision();
        //testPolynomialEqual();
        
        ArrayList< String[]> sFactorsList = findSFactor(graphListPath,pariResultPath);
        displaySFactorsList(sFactorsList);

        //Debug("graphList.txt","pariResult.txt");
        int size = sFactorsList.size();
        for(int i=size-1; i >=0 ; i--){
            if ( sFactorsList.get(i)[1].equals("1") ||sFactorsList.get(i)[2].equals("1") )
                     sFactorsList.remove(i);
        }

        System.out.println("---------excluding divisor graphID=1----------");
        displaySFactorsList(sFactorsList);
        
        
    }
    
//    public static int countSFGraphs() {
//       ArrayList< String[]> sFactorsList = FileIO.readSFactorsList("running/sFactors.txt");
//       ArrayList< String > SFGraphs = new ArrayList< String >();
//       for (String[] anFinding : sFactorsList ){
//           SFGraphs.add(anFinding[0]);
//       }
//       //FileIO.displayList(SFGraphs);
//       int size = SFGraphs.size();
//       int count = size;
//       boolean distinct = true;
//       //System.out.println(SFGraphs.size());
//       for (int i=0; i < size-1; i++){
//           distinct = true;
//           for (int j= i+1; j< size; j++){
//                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
//                    distinct=false;
//                }
//           }
//           if (!distinct) count--;
//       }
//       return count;
//    }
    
    public static int countSFGraphs2(ArrayList<String>inSFGraphs) {
       ArrayList< String> SFGraphs = inSFGraphs;
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int count = size;
       boolean distinct = true;
       System.out.println(SFGraphs.size());
       for (int i=1; i < size; i++){
           distinct = true;
           for (int j= 0; j< i; j++){
                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
                    distinct=false;
                }
           }
           if (!distinct) count--;
       }
       return count;
    }
    
    public static ArrayList<String> distinctSFGraphs(ArrayList<String> inSFGraphs) {
       ArrayList< String> SFGraphs = inSFGraphs;
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int sizeEnd = size;
       System.out.println(SFGraphs.size());
       for (int i= size-2; i >= 0; i--){
           for (int j= sizeEnd-1; j> i; j--){
                if (SFGraphs.get(i).equals(SFGraphs.get(j))){
                    SFGraphs.remove(i);
                }
           }
           sizeEnd = SFGraphs.size();
       }
       return SFGraphs;
    }
    
    public static int countSFGraphs3() {
       ArrayList< String> SFGraphs = FileIO.readSFactorsListHead("running/sFactors.txt");
       //FileIO.displayList(SFGraphs);
       int size = SFGraphs.size();
       int count = size;
       System.out.println(SFGraphs.size());
       for (int i=1; i < size; i++){
            if (SFGraphs.get(i).equals(SFGraphs.get(i-1))){
                count--;
            }       
       }
       return count;
    }
    
    

    public static void fullTest() throws IOException{
        //findSFactor("graphList.txt","pariResult.txt");
        //StabilityPolynomial.run();
        ArrayList<String> rawStr = FileIO.readFileGetStrings("running/graphList.txt");
        System.out.println("graph number:" + rawStr.size());
        
        ArrayList< String[]> sFactorsList = findSFactor("running/graphList.txt","running/pariResult.txt");
        //displaySFactorsList(sFactorsList);
        FileIO.saveSFactorsList(sFactorsList);
        displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
    }

    public static void main(String[] args) throws IOException {
        //findSFactorResult("graphList.txt","pariResult.txt");
        //showSFactorResult("graphList.txt","pariResult.txt");
        //ArrayList<String> test = ResultConverter.sfactorToAdjMatrixs("001010001010011010010=011X0111001110");
        //FileIO.displayList(test);

        //ReadMe:
        //(0)graphMatrix to graphList: GraphConverter.java
        //(1)graphList to PariCode:StabilityPolynomial.java
        //(2)PariCode to PariResult:run.sh "gp < pariCode.txt > pariResult.txt"
        //(3)PariResult to sFactorisations

        //0111111 111111 01111 1110 011 01 1
        //fullTest();
//        displaySFactorsList(FileIO.readSFactorsList("running/sFactors.txt"));
//        
//        
        ArrayList<String> SFGraphs = FileIO.readSFactorsListHead("running/sFactors.txt");
        ArrayList<String> distinctSFGraphs = distinctSFGraphs(SFGraphs);
        System.out.print(distinctSFGraphs.size());
        FileIO.writeStringsToFile(distinctSFGraphs,"running/distinctSFGraphs.txt");
      // System.out.print(countSFGraphs3());

    }

}
